
<p>Sada smo spremni za prikaz izvedbe zbrajala dvaju višeznamenkastih brojeva. Shemu sklopa lagano je nacrtati ako razmišljamo o načinu na koji smo ručno radili zbrajanje. No možemo si i pomoći. Vratimo se ponovno na onaj djelić programskog koda koji je obavljao zbrajanje:

<pre><code>  c[0] = 0; /* Početni prijenos je 0. */

  /* Zbrajanje: */
  for(int i = 0; i &lt; BROJ_ZNAMENKI; i++) {
    r[i] = (a[i] + b[i] + c[i]) % BAZA;
    c[i+1] = (a[i] + b[i] + c[i]) / BAZA;
  }</code></pre>

<p>i raspetljajmo ga (formalni naziv u engleskoj terminologiji je <i>loop-unrolling</i>). Kako je <code>BROJ_ZNAMENKI</code> bio jednak 5, dobivamo sljedeće:</p>

<pre><code>  c[0] = 0; /* Početni prijenos je 0. */

  /* i=0: */
  r[0] = (a[0] + b[0] + c[0]) % BAZA;
  c[1] = (a[0] + b[0] + c[0]) / BAZA;

  /* i=1: */
  r[1] = (a[1] + b[1] + c[1]) % BAZA;
  c[2] = (a[1] + b[1] + c[1]) / BAZA;

  /* i=2: */
  r[2] = (a[2] + b[2] + c[2]) % BAZA;
  c[3] = (a[2] + b[2] + c[2]) / BAZA;

  /* i=3: */
  r[3] = (a[3] + b[3] + c[3]) % BAZA;
  c[4] = (a[3] + b[3] + c[3]) / BAZA;

  /* i=4: */
  r[4] = (a[4] + b[4] + c[4]) % BAZA;
  c[5] = (a[4] + b[4] + c[4]) / BAZA;</code></pre>

<p>Primijetite, s obzirom da smo petlju razmotali, imamo pet puta strukturno jednak dio koda. Svaki dio dobiva <i>i</i>-tu znamenku od <i>a</i>, <i>i</i>-tu znamenku od <i>b</i> i ulazni prijenos za <i>i</i>-ti segment te generira <i>i</i>-tu znamenku rezultata i prijenos za <i>i</i>+1 segment. Sklopovska implementacija toga nije ništa drugo nego potpuno zbrajalo. Primijetite također da dio koji smo dobili za <i>i</i>=4 treba prijenos koji računa dio koji smo dobili za <i>i</i>=3 a on pak treba prijenos koji računa dio koji smo dobili za <i>i</i>=2, koji ... i tako sve do prvog dijela. Evo u nastavku takve sklopovske izvedbe koja se temelji na 5 potpunih zbrajala. Prikazana je interaktivna simulacija s potpunim zbrajalima za dekadski brojevni sustav. Vrijednost svake znamenke (i nultog, ulaznog prijenosa) možete mišem mijenjati. Isprobajte! Na ulaze je trenutno postavljeno <i>a</i> = <i>a</i><sub>4</sub><i>a</i><sub>3</sub><i>a</i><sub>2</sub><i>a</i><sub>1</sub><i>a</i><sub>0</sub> = 13672 i <i>b</i> = <i>b</i><sub>4</sub><i>b</i><sub>3</sub><i>b</i><sub>2</sub><i>b</i><sub>1</sub><i>b</i><sub>0</sub> = 32585.
</p>

<script>
@#page-include#(adders.js)
</script>

<div style="text-align: center;">
<canvas id="myCanvas1" width="900" height="230" oncontextmenu="return false;"></canvas><br>
Dekadsko zbrajalo dvaju 5-znamenkastih brojeva.
</div>

<script>
var addState1 = new additionState(5);
addState1.a[0].setValue(2);
addState1.a[1].setValue(7);
addState1.a[2].setValue(6);
addState1.a[3].setValue(3);
addState1.a[4].setValue(1);
addState1.b[0].setValue(5);
addState1.b[1].setValue(8);
addState1.b[2].setValue(5);
addState1.b[3].setValue(2);
addState1.b[4].setValue(3);

var model1 = [
  new adder("myCanvas1", addState1, 0, 10, true),
  new adder("myCanvas1", addState1, 1, 10, true),
  new adder("myCanvas1", addState1, 2, 10, true),
  new adder("myCanvas1", addState1, 3, 10, true),
  new adder("myCanvas1", addState1, 4, 10, true)
];

for(var i = 4; i >= 0; i--) {
  if(i==4) {
    model1[i].offsetX = 20;
    model1[i].showCarryLeft = true;
  } else {
    model1[i].offsetX = model1[i+1].offsetX+model1[i+1].getWidth();
    model1[i].showCarryLeft = false;
  }
  model1[i].showABLabels = true;
}
model1[0].cinState = 3;

var sc1 = new scene("myCanvas1", model1, addState1);
sc1.drawAll();
</script>

<p>Uzimajući u obzir da za zbrajanje dvaju višeznamenkastih brojeva na najnižoj poziciji nemamo ulaznog prijenosa, na tom bismo mjestu mogli umjesto potpunog zbrajala staviti poluzbrajalo. Takvo rješenje prikazano je kao interaktivna simulacijama dana u nastavku.</p>

<div style="text-align: center;">
<canvas id="myCanvas2" width="900" height="230" oncontextmenu="return false;"></canvas><br>
Dekadsko zbrajalo dvaju 5-znamenkastih brojeva.
</div>

<script>
var addState2 = new additionState(5);
addState2.a[0].setValue(2);
addState2.a[1].setValue(7);
addState2.a[2].setValue(6);
addState2.a[3].setValue(3);
addState2.a[4].setValue(1);
addState2.b[0].setValue(5);
addState2.b[1].setValue(8);
addState2.b[2].setValue(5);
addState2.b[3].setValue(2);
addState2.b[4].setValue(3);

var model2 = [
  new adder("myCanvas2", addState2, 0, 10, false),
  new adder("myCanvas2", addState2, 1, 10, true),
  new adder("myCanvas2", addState2, 2, 10, true),
  new adder("myCanvas2", addState2, 3, 10, true),
  new adder("myCanvas2", addState2, 4, 10, true)
];

for(var i = 4; i >= 0; i--) {
  if(i==4) {
    model2[i].offsetX = 20;
    model2[i].showCarryLeft = true;
  } else {
    model2[i].offsetX = model2[i+1].offsetX+model2[i+1].getWidth();
    model2[i].showCarryLeft = false;
  }
  model2[i].showABLabels = true;
}
model2[0].cinState = 0;

var sc2 = new scene("myCanvas2", model2, addState2);
sc2.drawAll();
</script>

<p>Iako je poluzbrajalo jednostavniji (pa time i jeftiniji) sklop za proizvodnju, prva inačica višeznamenkastog zbrajala koju smo prikazali preferirana je realizacija jer nam dopušta da upravljamo početnim prijenosom, što možemo iskoristiti za ulančavanje više takvih zbrajala kako bismo podržali zbrajanje brojeva s još više znamenaka. Osim te, taj će ulazni prijenos imati još jednu praktičnu primjenu o kojoj ćemo pričati na predavanjima.</p>

<p>Simbol zbrajala dvaju 5-znamenkastih brojeva prikazan je na slici 1.</p>

<figure class="mlFigure">
<img src="@#file#(rca.svg)" alt="Simbol zbrajala dvaju 5-znamenkastih brojeva"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Simbol zbrajala dvaju 5-znamenkastih brojeva.</figcaption>
</figure>

<p>Zbrajalo dvaju 5-bitnih binarnih brojeva prikazano je u interaktivnoj simulaciji u nastavku.</p>

<div style="text-align: center;">
<canvas id="myCanvas3" width="900" height="230" oncontextmenu="return false;"></canvas><br>
Binarno zbrajalo dvaju 5-znamenkastih brojeva.
</div>

<script>
var addState3 = new additionState(5);
addState3.a[0].setValue(0);
addState3.a[1].setValue(0);
addState3.a[2].setValue(0);
addState3.a[3].setValue(0);
addState3.a[4].setValue(0);
addState3.b[0].setValue(1);
addState3.b[1].setValue(1);
addState3.b[2].setValue(1);
addState3.b[3].setValue(1);
addState3.b[4].setValue(1);

var model3 = [
  new adder("myCanvas3", addState3, 0, 2, true),
  new adder("myCanvas3", addState3, 1, 2, true),
  new adder("myCanvas3", addState3, 2, 2, true),
  new adder("myCanvas3", addState3, 3, 2, true),
  new adder("myCanvas3", addState3, 4, 2, true)
];

for(var i = 4; i >= 0; i--) {
  if(i==4) {
    model3[i].offsetX = 20;
    model3[i].showCarryLeft = true;
  } else {
    model3[i].offsetX = model3[i+1].offsetX+model3[i+1].getWidth();
    model3[i].showCarryLeft = false;
  }
  model3[i].showABLabels = true;
}
model3[0].cinState = 3;

var sc3 = new scene("myCanvas3", model3, addState3);
sc3.drawAll();
</script>

<p>Primjer koji je već podešen u prethodnoj simulaciji je zbrajanje 00000 i 11111 pri čemu je ulazni prijenos 0. Promijenite ulazni prijenos na 1. Vidite li što se dogodi kao posljedica?</p>

<p>Kako biste to lakše vidjeli, u nastavku je ponovljena interaktivna simulacija pri čemu je svako potpuno zbrajalo podešeno tako da ima vrijeme kašnjenja od pola sekunde. To znači da, kad god se promijene ulazi tog potpunog zbrajala, nova pripadna vrijednost rezultata i prijenosa pojavit će se pola sekunde kasnije na njegovim izlazima. Vidite li sada što se događa s bitom prijenosa kroz vrijeme?</p>

<div style="text-align: center;">
<canvas id="myCanvas4" width="900" height="230" oncontextmenu="return false;"></canvas><br>
Binarno zbrajalo dvaju 5-znamenkastih brojeva pri čemu svako potpuno zbrajalo ima vrijeme kašnjenja od pola sekunde.
</div>

<script>
var addState4 = new additionState(5);
addState4.a[0].setValue(0);
addState4.a[1].setValue(0);
addState4.a[2].setValue(0);
addState4.a[3].setValue(0);
addState4.a[4].setValue(0);
addState4.b[0].setValue(1);
addState4.b[1].setValue(1);
addState4.b[2].setValue(1);
addState4.b[3].setValue(1);
addState4.b[4].setValue(1);

var model4 = [
  new adder("myCanvas4", addState4, 0, 2, true),
  new adder("myCanvas4", addState4, 1, 2, true),
  new adder("myCanvas4", addState4, 2, 2, true),
  new adder("myCanvas4", addState4, 3, 2, true),
  new adder("myCanvas4", addState4, 4, 2, true)
];

for(var i = 4; i >= 0; i--) {
  if(i==4) {
    model4[i].offsetX = 20;
    model4[i].showCarryLeft = true;
  } else {
    model4[i].offsetX = model4[i+1].offsetX+model4[i+1].getWidth();
    model4[i].showCarryLeft = false;
  }
  model4[i].showABLabels = true;
  model4[i].delay = 500;
}
model4[0].cinState = 3;

var sc4 = new scene("myCanvas4", model4, addState4);
sc4.drawAll();
</script>

<p>Ako ste isprobali opisani scenarij, tada ste primijetili da se vektor prijenosa (vektor izgrađen od bitova <i>c</i><sub>5</sub><i>c</i><sub>4</sub><i>c</i><sub>3</sub><i>c</i><sub>2</sub><i>c</i><sub>1</sub><i>c</i><sub>0</sub>) mijenja iz 000000 u 000001 pa u 000011 pa u 000111 pa u 001111 pa u 011111 pa u 111111, te slično u drugom smjeru. Kako se ovaj proces ne događa trenutno već traje određeno vrijeme, taj niz binarnih uzoraka ljude je podsjetio na širenje odnosno mreškanje valova na površini vode. Iz tog razloga, ovako izgrađeno zbrajalo dvaju višeznamenkastih brojeva u engleskoj terminologiji nazvano je <i>Ripple Carry Adder</i> (kraće, RCA). Mi ćemo ga na ovom kolegiju zvati <i>paralelno zbrajalo</i> što bi nas trebalo asocirati na činjenicu da sklopu sve znamenke oba broja na ulaze dovodimo istovremeno (paralelno).</p>

<div class="mlNote">
<p>Zbrajalo višeznamenkastih brojeva također je kombinacijski sklop. Uočite, međutim, da je način na koji smo ga izgradili rezultirao izvedbom s puno razina logike. Ukupni utrošak logičkih sklopova kod ove izvedbe je relativno malen.</p>
<p>Opisano zbrajalo mogli bismo (pokušati) projektirati i na uobičajen način: napisali bismo tablicu istinitosti koja bi imala ukupno 11 varijabli (5 bitova od <i>a</i>, 5 bitova od <i>b</i> te ulazni prijenos) i koja bi definirala 6-bitnu vektorsku funkciju (5-komponenti bi bilo za <i>r</i> i jedna za izlazni prijenos). Ta bi tablica imala \(2^{11}\) redaka. Promotrimo li sada primjerice bit rezultata najmanje težine, tamo će u \(2^{10}\) redaka biti jedinice (i u isto toliko redaka nule - jer je pola suma parno a pola neparno). Implementiramo li tu funkciju kao sumu minterma, završit ćemo s \(2^{10}\) 11-ulaznih sklopova I te jednim sklopom ILI koji ima \(2^{10}\) ulaza, samo za taj bit rezultata. Slično možemo pogledati i za preostale komponente. Kada bismo takve implementacije mogli tehnološki izvesti, imali bismo ostvarenje koje radi u dvije razine logike i koje je, uz pretpostavku da su osnovni logički sklopovi brzi (što baš ne drži vodu kada broj ulaza u sklop raste), i samo brzo. Efekt propagacije prijenosa ne bi bio izražen.</p>
<p>Prikazana realizacija tipičan je primjer <i>trade-offa</i> koji radimo u inženjerskoj praksi: na jednoj strani je realizacija koja ima puno razina logike ali zato troši malo sklopova; na drugoj strani je realizacija koja ima vrlo malo razina logike (pa je brza) ali troši izuzetno puno sklopova.</p>
<p>U ovom specifičnom slučaju gdje je problem propagacija prijenosa, postoje i drugi načini kako se vrijeme stabilizacije rezultata može skratiti. Više o tome bit će riječi na predavanju.</p>
</div>





